/**
 * @description
 * @author yangjunbao
 * @since 2016-07-14 19:57:04
 * @version 1.0.0.0
 * @file src/applyMiddleware.ts
 * @desc src/applyMiddleware.ts
 */
'use strict';
var compose_1 = require('./utils/compose');
function applyMiddleware() {
    var middlewares = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        middlewares[_i - 0] = arguments[_i];
    }
    return function (createStore) {
        return function (reducer, preloadedState, enhancer) {
            var store = createStore(reducer, preloadedState, enhancer);
            var dispatch = store.dispatch;
            var api = {
                getState: store.getState,
                dispatch: function (action) { return dispatch(action); }
            };
            var chain = middlewares.map(function (middleware) { return middleware(api); });
            // store.dispatch = compose(...chain)(store.dispatch)
            // return store
            // FIXME: WTF, this cannot pass test, but the follow passed
            dispatch = compose_1.default.apply(void 0, chain)(store.dispatch);
            store.dispatch = dispatch;
            return store;
        };
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = applyMiddleware;
