/**
 * @description
 * @author yangjunbao
 * @since 2016-07-14 20:12:03
 * @version 1.0.0.0
 * @file src/bindActionCreators.ts
 * @desc src/bindActionCreators.ts
 */
'use strict';
function bindActionCreator(actionCreator, dispatch) {
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        return dispatch(actionCreator.apply(void 0, args));
    };
}
exports.bindActionCreator = bindActionCreator;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = function (actionCreators, dispatch) {
    if (typeof actionCreators === 'function') {
        return bindActionCreator(actionCreators, dispatch);
    }
    return Object.keys(actionCreators).reduce(function (prev, curr) {
        if (typeof actionCreators[curr] === 'function') {
            prev[curr] = bindActionCreator(actionCreators[curr], dispatch);
        }
        return prev;
    }, {});
};
