/**
 * @description
 * @author yangjunbao
 * @since 2016-07-14 21:11:18
 * @version 1.0.0.0
 * @file src/combineReducers.ts
 * @desc src/combineReducers.ts
 */
'use strict';
function combineReducers(reducers) {
    var keys = Object.keys(reducers).filter(function (key) { return typeof reducers[key] === 'function'; });
    return function combination(state, action) {
        if (state === void 0) { state = {}; }
        var changed = false;
        var newState = {};
        keys.forEach(function (name) {
            newState[name] = reducers[name](state[name], action);
            newState[name] !== state[name] && (changed = true);
        });
        return changed ? newState : state;
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = combineReducers;
