/**
 * @description
 * @author yangjunbao
 * @since 2016-07-14 19:57:19
 * @version 1.0.0.0
 * @file src/compose.ts
 * @desc src/compose.ts
 */
'use strict';
function default_1() {
    var funcs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        funcs[_i - 0] = arguments[_i];
    }
    if (funcs.length === 0) {
        return function (arg) { return arg; };
    }
    if (funcs.length === 1) {
        return funcs[0];
    }
    var last = funcs.pop();
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        return funcs.reduceRight(function (prevReturn, currFn) { return currFn(prevReturn); }, last.apply(void 0, args));
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = default_1;
