/**
 * @description
 * @author acrazing
 * @since 2016-06-29 12:02:16
 * @version 1.0.0.0
 * @file webpack.config.js
 * @desc webpack.config.js
 */

const webpack = require('webpack')
module.exports = {
  plugins: [
    new webpack.HotModuleReplacementPlugin(),
    new webpack.DefinePlugin({
      'process.env.NODE_ENV': JSON.stringify(process.env.NODE_ENV),
    }),
  ],
  resolve: {
    modulesDirectories: ['node_modules'],
    extensions: ['', '.ts', '.tsx', '.js', '.jsx', '.node']
  },
  module: {
    loaders: [
      {
        test: /\.tsx?$/,
        loader: 'ts-loader?configFileName=tsconfig.demo.json',
      },
      {
        test: /\.jsx?$/,
        loader: 'babel-loader?' + JSON.stringify({ presets: ['es2015'] }),
      }
    ],
  },
}
